﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports Infragistics.Controls.Menus

Public Class ViewModel
    Public Property Menus() As ObservableCollection(Of clsMenuItem)
        Get
            Return _mMenus
        End Get
        Set(value As ObservableCollection(Of clsMenuItem))
            _mMenus = value
        End Set
    End Property
    Private _mMenus As ObservableCollection(Of clsMenuItem)

    Public Property SelectedMenuItems() As Object()
        Get
            Return _mSelectedMenuItems
        End Get
        Set(value As Object())
            _mSelectedMenuItems = value
            If _mSelectedMenuItems IsNot Nothing Then
                _mSelectedCopy = New ObservableCollection(Of clsMenuItem)
                For Each obj As Object In _mSelectedMenuItems
                    Dim temp As clsMenuItem = DirectCast(obj, clsMenuItem)
                    _mSelectedCopy.Add(temp)
                Next
            End If
        End Set
    End Property
    Private _mSelectedMenuItems As Object()

    Public Property SelectedCopy As ObservableCollection(Of clsMenuItem)
        Get
            Return _mSelectedCopy
        End Get
        Set(value As ObservableCollection(Of clsMenuItem))
            _mSelectedCopy = value
        End Set
    End Property
    Private _mSelectedCopy As ObservableCollection(Of clsMenuItem)

    Private NoLevels As Integer = 1
    Public Sub New()
        CreateData()
    End Sub

    Private RootList As String() = {"Current Menu", "New Menu", "Old Menu", "Buffet Menu", "Holiday Menu", "Special Menu", _
    "Elegant Menu", "Family Menu", "Small Affair Menu", "Local Menu"}

    Private ChildList As String() = {"Current Menu Child", "New Menu Child", "Old Menu Child", "Buffet Menu Child", "Holiday Menu Child", "Special Menu Child", _
    "Elegant Menu Child", "Family Menu Child", "Small Affair Menu Child", "Local Menu Child"}


    Private Sub CreateData()
        Dim r As New Random()
        Menus = New ObservableCollection(Of clsMenuItem)()
        For i As Integer = 0 To 9
            Dim gd As New clsMenuItem() With { _
                .ID = i, _
                .Description = RootList(r.[Next](10)), _
                .IsSelected = False, _
                .Children = New ObservableCollection(Of clsMenuItem)() _
            }
			AddChildren(gd, 3)
            Menus.Add(gd)
        Next

        For Each menu As Object In Menus
            Dim childCnt As Integer = menu.Children.Count()
            Dim selCnt As Integer = 0
            For i As Integer = 0 To menu.Children.Count() - 1
                If menu.Children(i).IsSelected = True Then
                    selCnt += 1
                End If
            Next

            If selCnt > 0 Then
                If selCnt = childCnt Then
                    menu.IsSelected = True
                Else
                    menu.IsSelected = Nothing
                End If

            End If
        Next

        Menus(3).Children(0).Children.Add(New clsMenuItem() With {
                                            .ID = 100,
                                            .Description = "Level 2 Child 1",
                                            .IsSelected = False,
        .Children = New ObservableCollection(Of clsMenuItem)()
                                            })
        Menus(3).Children(0).Children.Add(New clsMenuItem() With {
                                            .ID = 101,
                                            .Description = "Level 2 Child 2",
                                            .IsSelected = False,
                                            .Children = New ObservableCollection(Of clsMenuItem)()
                                            })


    End Sub


    Private Sub AddChildren(gd As clsMenuItem, levelNo As Integer)
        Dim r As New Random()
        Dim NoChildren As Integer = r.[Next](3, 15)
        Dim levelStr As String = "1"
        For i As Integer = 0 To levelNo - 1
            levelStr += "0"
        Next


        Dim levelMult As Integer = Integer.Parse(levelStr)
        For i As Integer = 0 To NoChildren - 1
            Dim gd2 As New clsMenuItem() With { _
                .ID = levelMult + i, _
                .Description = ChildList(r.[Next](10)), _
                .IsSelected = False, _
                .Children = New ObservableCollection(Of clsMenuItem)() _
            }

            If levelNo < NoLevels Then
                AddChildren(gd2, levelNo + 1)
            End If

            gd.Children.Add(gd2)
        Next
    End Sub



End Class

Public Class clsMenuItem
    Implements INotifyPropertyChanged

   


    Private m_id As Integer
    Private name As String
    Private m_isSelected As Boolean

    Public Property Children() As ObservableCollection(Of clsMenuItem)
        Get
            Return m_Children
        End Get
        Set(value As ObservableCollection(Of clsMenuItem))
            m_Children = value
        End Set
    End Property
    Private m_Children As ObservableCollection(Of clsMenuItem)


    Public Property ID() As Integer
        Get
            Return m_id
        End Get
        Set(value As Integer)
            If m_id <> value Then
                m_id = value
                OnPropertyChanged("ID")
            End If
        End Set
    End Property

    Public Property Description() As String
        Get
            Return name
        End Get
        Set(value As String)
            If name <> value Then
                name = value
                OnPropertyChanged("Description")
            End If
        End Set
    End Property

    Public Property IsSelected() As Boolean
        Get
            Return m_isSelected
        End Get
        Set(value As Boolean)
            If m_isSelected <> value Then
                m_isSelected = value
                OnPropertyChanged("IsSelected")
            End If
        End Set
    End Property

    Public Property IsExpanded() As Boolean
        Get
            Return m_isSelected
        End Get
        Set(value As Boolean)
            If m_isSelected <> value Then
                m_isSelected = value
                OnPropertyChanged("IsExpanded")
            End If
        End Set
    End Property


    Public Event PropertyChanged(sender As Object, e As PropertyChangedEventArgs) Implements INotifyPropertyChanged.PropertyChanged
    Protected Sub OnPropertyChanged(propertyName As String)

        Try
            Dim propEventArgs As New PropertyChangedEventArgs(propertyName)
            RaiseEvent PropertyChanged(Me, propEventArgs)
        Catch

        End Try
    End Sub

End Class

Public Class ItemVisConverter
    Implements IValueConverter
	Public Function Convert(InValue As Object, InTargetType As Type, InParameter As Object, InCulture As Globalization.CultureInfo) As Object Implements IValueConverter.Convert
		Dim node As XamDataTreeNode
			Dim tree As XamDataTree

			If InValue Is Nothing Then
				Return Binding.DoNothing
			End If

			node = DirectCast(InValue, XamDataTreeNodeDataContext).Node
			tree = node.NodeLayout.Tree

			If InValue.[GetType]() <> GetType([Boolean]) Then
				Select Case InParameter.ToString
					Case "Expand"
						If node.HasChildren AndAlso node.Manager.ParentNode IsNot Nothing AndAlso Not node.IsExpanded Then	 ' Parent Node but not Root Parent Node
							Return Visibility.Visible
						Else
							Return Visibility.Collapsed
						End If
					Case "ExpandAll"
						If Not node.IsExpanded AndAlso node.Manager.ParentNode Is Nothing AndAlso tree.Nodes.Where(Function(nd) Not nd.IsExpanded).Count > 0 Then
							Return Visibility.Visible
						Else
							Return Visibility.Collapsed
						End If
					Case "CollapseAll"
						If node.IsExpanded AndAlso node.Manager.ParentNode Is Nothing AndAlso tree.Nodes.Where(Function(nd) nd.IsExpanded).Count > 0 Then
							Return Visibility.Visible
						Else
							Return Visibility.Collapsed
						End If
					Case "Collapse"
						If node.HasChildren AndAlso node.Manager.ParentNode IsNot Nothing AndAlso node.IsExpanded Then	 ' Parent Node but not Root Parent Node
							Return Visibility.Visible
						Else
							Return Visibility.Collapsed
						End If
				End Select

			End If

			Return Binding.DoNothing
	End Function

    Public Function ConvertBack(value As Object, targetType As Type, parameter As Object, culture As Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class